// stand for protodome's 4000ad album - scruss, 2020-08
// see https://protodome.com/4000AD/ for details

board = [120, 84, 2];   // pcb dimensions
panel = [80, 80];       // info panel dimensions
panel_offs = [board.x - panel.x - 2, 2]; // bl corner of info

thick = 8;
eps = 1e-3;
extra=0.2;
$fn=16;
base_dia = 10; // but scale 2x in height

module flat() {
    union() {
        linear_extrude(height=board.z, center=true)square([board.x, board.y]);
        linear_extrude(height=thick, center=true)translate(panel_offs)square(panel);
    }
}

module flat_allowance() {
    translate([-board.x/2, 0, board.z])minkowski() {
        union() {
            for (i=[-3:3]) {
                rotate([90+5*i,0,0])flat();
            }
            rotate([0,90,0])cylinder(d=board.z + extra/2, h=board.x);
        }
        sphere(r=extra);
    }
}

difference() {
    intersection() {
        union() {
            rotate([0,90,0])scale([2,1,1])cylinder(d=base_dia, h=board.x, center=true);
            rotate_extrude()translate([board.x/2,0,0])scale([1,2])circle(d=base_dia);
        }
        cylinder(r=board.x, h=2 * base_dia);
    }
    flat_allowance();
}
